/* Eratosthenes Sieve benchmark */

#define true 1
#define false 0
#define size 8190
#define sizepl 8191

char flags[sizepl];

int main()
{
	int i, prime, k, count, iter;

	printf("10 iterations\n");

	iter = 1;
	while (iter <= 10) {
		count = 0;
		i = 0;
		while (i <= size) {
			flags[i] = true;
			i++;
		}
		i = 0;
		while (i <= size) {
			if (flags[i]) {
				prime = i + i + 3;
				k = i + prime;
				while (k <= size) {
					flags[k] = false;
					k = k + prime;
				}
				count++;
			}
			i++;
		}
		iter++;
	}

	printf("\n%d primes\n", count);
	exit(0);
}
